#!/bin/sh
# the next line restarts using wish \
exec wish "$0" "$@"

#    Copyright 2003 Regis Damongeot

#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


#window title
wm title . "TkDVD 3.8"
wm geometry . 700x520
wm protocol . WM_DELETE_WINDOW { save_options; destroy . }
set burn_type "burn_dvd"
set v_create_iso "no"
set burning_device "/dev/sr0"
set burn_command "growisofs"
set volume_id ""
set volume_id_o ""
set option_udf_ext ""
set option_joliet_ext "-J"
set option_rr_ext "-r"
set option_pad "-pad"
set file_list ""
set excluded_file_list ""
set only_one_file ""
set input ""
set total_file_size_f "0 KB"
set space_left_f "4.377 GB"
set dvd_size "4589850"
set selected_directory "[pwd]"
set iso_file ""
set t_session "-use-the-force-luke=tty -Z"
set option_dvd_compat "-dvd-compat"
set option_auto_refresh_space "1"
set option_overburn ""
set burn_speed ""
set langage "English"
set i18n_langage_list ""
set command_line "growisofs $t_session $burning_device $option_joliet_ext $option_rr_ext $burn_speed $option_dvd_compat $option_pad -graft-points"
#needed to not have too large precision when showing total files size
set tcl_precision 4

#set fullpath to source scripts (if TkDVD not launch from it install direcotory)
set source_directory "[info script]"
if { [file pathtype $source_directory] == "absolute" } {
	set source_directory [file dirname $source_directory]
} else {
	set source_directory "[file dirname [pwd]/[info script]]"
}

#source combobox code
source /usr/share/tkdvd/src/combobox.tcl
#source save/load config options procedure
source /usr/share/tkdvd/src/save_load_options.tcl
#load user default options
load_options
#change command line variable according to loaded values
set command_line "growisofs $t_session $burning_device $option_joliet_ext $option_rr_ext $option_dvd_compat $option_pad -graft-points"
#source internationalisation variables
source /usr/share/tkdvd/src/internationalization.tcl
#source of the total file size count procedure
source /usr/share/tkdvd/src/proc_total_file_size.tcl
#source of the refresh command line procedure (main procedure)
source /usr/share/tkdvd/src/proc_refresh_cmd_line.tcl
#source of excluded file window and its needed procedures
source /usr/share/tkdvd/src/excluded_file_window.tcl
#source advanced options window procedure
source /usr/share/tkdvd/src/advanced_options_window.tcl
#source main TkDVD window
source /usr/share/tkdvd/src/main_window.tcl


#beginning of the procedure part

proc file_list_w_modif_dir { file_list_to_modif } {
	#puts "$file_list_to_modif"
	set file_list_to_modif_f ""
	#set modified false
	for { set i 0 } { $i < [llength $file_list_to_modif]} { incr i } {
		if { [file isdirectory [lindex $file_list_to_modif $i]] } {
			set file_list_to_modif [lreplace $file_list_to_modif $i $i "[lindex [split [lindex $file_list_to_modif $i] /] end]/=[lindex $file_list_to_modif $i]"]
		} else {
		}
	}
	#if { $modified == true } { return [eval concat $file_list_to_modif] } else { return $file_list_to_modif }
	return $file_list_to_modif
}

#validatecommand must be after the called proc
.f_burn_dev.burn_device configure -validate focus -validatecommand refresh_cmd_line

proc choose_iso_file {} {
	global iso_file burn_type burning_device
	set iso_file_o ""
	if { $burn_type == "burn_iso" } {
		set iso_file_o [tk_getOpenFile -defaultextension .iso -title "$i18n_select_iso_image"]
		if { [llength $iso_file_o] > 1} {
			set iso_file [lindex $iso_file_o 0]
			for { set i 1} {$i < [llength $iso_file_o]} {incr i} {
				set iso_file "$iso_file\\ [lindex $iso_file_o $i]"
			}
		} else {
			set iso_file $iso_file_o
		}
	} else {
		set burning_device ""
		#set iso_file [tk_chooseDirectory -mustexist 0]
		set iso_file [tk_getSaveFile]
		set burning_device "-o"
		lappend burning_device $iso_file
	}
	refresh_cmd_line
}

proc check_volume_id {} {
	global volume_id volume_id_o
	set volume_id ""
	if { $volume_id_o == "" } {
		set volume_id ""
	} elseif { [llength $volume_id_o] > 1} {
			set volume_id [lindex $volume_id_o 0]
			for { set i 1} {$i < [llength $volume_id_o]} {incr i} {
				set volume_id "$volume_id\\ [lindex $volume_id_o $i]"
			}
			set volume_id "-V $volume_id"
		} else { set volume_id "-V $volume_id_o" }
}

proc add_file {files} {
	global file_list option_auto_refresh_space
	if { $files != "" } {
		#foreach needed for multiple files selection
		foreach i $files {
			lappend file_list $i
		}
		#puts "$file_list"
		if { $option_auto_refresh_space == "1" } {
			refresh_total_file_size
		}
		refresh_cmd_line
	} else {
	#puts "No file chosen"
	}
}

proc add_d {} {
	global file_list option_auto_refresh_space
	set temp [tk_chooseDirectory]
	set temp_f "[lindex $temp 0]"
	if { $temp != "" } {
		#for {set i 1} { $i < [llength $temp] } {incr i} {
		#	append temp_f "\\ [lindex $temp $i]"
		#}
		lappend file_list $temp
		#refresh command line entry after checking space used to check overburn condition
		if { $option_auto_refresh_space == "1" } {
			refresh_total_file_size
		}
		refresh_cmd_line
	}
}

proc delete_files {} {
	global file_list
	if { "[.file_list.file_list curselection]" == "" } {
	} else {
		set file_list [lreplace $file_list [.file_list.file_list curselection] [.file_list.file_list curselection]]
		#refresh command line entry after checking space used to check overburn condition
		refresh_total_file_size
		refresh_cmd_line
	}
}

proc launch {burn_type} {
	global input command_line burning_device i18n_growisofs_mkisofs_output i18n_close
	#if output window not already created, we create it
	if { ! [winfo exists .output_window] } {
		toplevel .output_window -highlightthickness 1 -highlightcolor blue -background #f5f5f5
		wm title .output_window "$i18n_growisofs_mkisofs_output"
		frame .output_window.f_main
		text .output_window.f_main.log -heigh 10 -bg #f5f5f5 -relief ridge -setgrid true -yscrollcommand { .output_window.f_main.scroll_bar set }
		scrollbar .output_window.f_main.scroll_bar -command { .output_window.f_main.log yview }
		button .output_window.b_close -highlightbackground blue -width 7 -text "$i18n_close" -command { destroy .output_window; refresh_cmd_line }
		
		pack .output_window.f_main.log -fill both -side left -expand 1
		pack .output_window.f_main.scroll_bar -fill y -side right
		pack .output_window.f_main -fill both -expand 1
		pack .output_window.b_close
	}
	.f_burn.go_button configure -state disabled
	if { $burn_type == "burn" } {
		if {[catch {open "|$command_line |& cat"} input]} {
			#one blank line to increase readability
			.output_window.f_main.log insert end "$command_line\n\n"
		} else {
			fileevent $input readable log_proc
			#one blank line to increase readability
			.output_window.f_main.log insert end "$command_line\n\n"
		}
	} else {
		# $burn_type= "" or "force" or "blank" => format
		if {[catch {open "|dvd+rw-format $burn_type $burning_device |& cat"} input]} {
			#one blank line to increase readability
			.output_window.f_main.log insert end "dvd+rw-format $burn_type $burning_device\n\n"
		} else {
			fileevent $input readable log_proc
			#one blank line to increase readability
			.output_window.f_main.log insert end "dvd+rw-format $burn_type $burning_device\n\n"
		}
	}
	after 4000 refresh_cmd_line
}

proc choose_format {} {
#i18n
global i18n_erase i18n_close i18n_full_format i18n_normal_format i18n_quick_format i18n_erase_dvdrw
if { ! [winfo exists .format_window] } {
	
	toplevel .format_window -highlightthickness 1 -highlightcolor blue -background #f5f5f5
	wm title .format_window "$i18n_erase_dvdrw"
	
	frame .format_window.f_format_type -background #f5f5f5
	
	radiobutton .format_window.f_format_type.options_full_f -bg #f5f5f5 -activebackground #f5f5f5 -highlightbackground #f5f5f5 -text "$i18n_full_format" -variable format_type -value "-blank"
	radiobutton .format_window.f_format_type.options_normal_f -bg #f5f5f5 -activebackground #f5f5f5 -highlightbackground #f5f5f5 -text "$i18n_normal_format" -variable format_type -value "-force"
	radiobutton .format_window.f_format_type.options_quick_f -bg #f5f5f5 -activebackground #f5f5f5 -highlightbackground #f5f5f5 -text "$i18n_quick_format" -variable format_type -value ""
	
	button .format_window.b_erase -highlightbackground red -text "$i18n_erase" -command { launch $format_type; destroy .format_window}
	button .format_window.b_close -highlightbackground red -text "$i18n_close" -command { destroy .format_window}
	
	pack .format_window.f_format_type.options_quick_f -side left
	pack .format_window.f_format_type.options_normal_f -side left
	pack .format_window.f_format_type.options_full_f -side left
	pack .format_window.f_format_type -fill x -padx {0 12}
	pack .format_window.b_close .format_window.b_erase -fill x -side right -padx {0 12} -pady {6 6}
	
	.format_window.f_format_type.options_quick_f select
}
}

proc log_proc {} {
	global input i18n_writing_finished
	if [eof $input] {
		catch { close $input }
		.output_window.f_main.log insert end "$i18n_writing_finished"
		.output_window.f_main.log see end
	} else {
		gets $input line
		.output_window.f_main.log insert end $line\n
		.output_window.f_main.log see end
	}
}

proc set_visible_options {} {
	global burn_type v_create_iso
	if { $burn_type == "burn_dvd" &&  $v_create_iso == "no" } {
		.f_first_step_iso.b_open_iso configure -state disabled
		.f_only_create_iso.only_create_iso configure -state normal
		.f_vol_name.label_vname configure -state normal
		.f_vol_name.volume_name configure -state normal
		.f_first_step_b.add configure -state normal
		.f_first_step_b.add_d configure -state normal
		.f_first_step_b.delete configure -state normal
		.f_first_step_b.clear configure -state normal
		.f_first_step_b.excluded_files configure -state normal
		.file_list.file_list configure -state normal
		.f_upper_file_list.l_file_size configure -state normal
		.f_upper_file_list.l_space_left configure -state normal
		.f_burn_dev.l_burn_device configure -state normal
		.f_burn_dev.burn_device configure -state normal
		if { [winfo exists .advanced_options_window] } {
			.advanced_options_window.options_oth.pad configure -state normal
			.advanced_options_window.udf_radiobuttons.udf_ext configure -state normal
			.advanced_options_window.udf_radiobuttons.dvd_video_ext configure -state normal
			.advanced_options_window.udf_radiobuttons.udf_ext_off configure -state normal
			.advanced_options_window.rr_radiobuttons.rr_ext_off configure -state normal
			.advanced_options_window.rr_radiobuttons.rra_ext configure -state normal
			.advanced_options_window.rr_radiobuttons.rr_ext configure -state normal
			.advanced_options_window.options_fs.joliet_ext configure -state normal
			.advanced_options_window.options_oth.burn_speed configure -state normal
			.advanced_options_window.options_oth.overburn configure -state normal
			.advanced_options_window.options_oth.multisession configure -state normal
			.advanced_options_window.options_oth.monosession configure -state normal
		}
	} elseif { $burn_type == "burn_dvd" && $v_create_iso == "yes" } {
		.f_first_step_iso.b_open_iso configure -state normal
		.f_burn_dev.l_burn_device configure -state disabled
		.f_burn_dev.burn_device configure -state disabled
		if { [winfo exists .advanced_options_window] } {
			.advanced_options_window.options_oth.pad configure -state normal
			.advanced_options_window.options_fs.joliet_ext configure -state normal
			.advanced_options_window.udf_radiobuttons.udf_ext configure -state normal
			.advanced_options_window.udf_radiobuttons.udf_ext_off configure -state normal
			.advanced_options_window.udf_radiobuttons.dvd_video_ext configure -state normal
			.advanced_options_window.rr_radiobuttons.rr_ext_off configure -state normal
			.advanced_options_window.rr_radiobuttons.rr_ext configure -state normal
			.advanced_options_window.rr_radiobuttons.rra_ext configure -state normal
			.advanced_options_window.options_oth.burn_speed configure -state disabled
			.advanced_options_window.options_oth.overburn configure -state disabled
			.advanced_options_window.options_oth.multisession configure -state disabled
			.advanced_options_window.options_oth.monosession configure -state disabled
		}
	} elseif { $burn_type == "burn_iso" } {
		.f_first_step_iso.b_open_iso configure -state normal
		.f_only_create_iso.only_create_iso configure -state disabled
		.f_vol_name.label_vname configure -state disabled
		.f_vol_name.volume_name configure -state disabled
		.f_first_step_b.add configure -state disabled
		.f_first_step_b.add_d configure -state disabled
		.f_first_step_b.delete configure -state disabled
		.f_first_step_b.clear configure -state disabled
		.f_first_step_b.excluded_files configure -state disabled
		.file_list.file_list configure -state disabled
		.f_upper_file_list.l_file_size configure -state disabled
		.f_upper_file_list.l_space_left configure -state disabled
		.f_burn_dev.l_burn_device configure -state normal
		.f_burn_dev.burn_device configure -state normal
		if { [winfo exists .advanced_options_window] } {
			.advanced_options_window.options_oth.pad configure -state disabled
			.advanced_options_window.udf_radiobuttons.udf_ext configure -state disabled
			.advanced_options_window.udf_radiobuttons.udf_ext_off configure -state disabled
			.advanced_options_window.udf_radiobuttons.dvd_video_ext configure -state disabled
			.advanced_options_window.rr_radiobuttons.rr_ext_off configure -state disabled
			.advanced_options_window.rr_radiobuttons.rra_ext configure -state disabled
			.advanced_options_window.rr_radiobuttons.rr_ext configure -state disabled
			.advanced_options_window.options_fs.joliet_ext configure -state disabled
			.advanced_options_window.options_oth.burn_speed configure -state normal
			.advanced_options_window.options_oth.overburn configure -state normal
			.advanced_options_window.options_oth.multisession configure -state normal
			.advanced_options_window.options_oth.monosession configure -state disabled
		}
	}
}

proc burn_iso_proc {} {
	global burn_command t_session burning_device option_dvd_compat option_overburn v_create_iso option_dvd_compat
	set burn_command "growisofs"
	set t_session "-use-the-force-luke=tty -Z"
	set option_dvd_compat "-dvd-compat"
	set option_overburn ""
	load_options
	set v_create_iso "no"
	set_visible_options
	set volume_id ""
	set volume_id_o ""
	set option_joliet_ext ""
	set option_rr_ext ""
	set option_rra_ext ""
	set option_pad ""
	set option_dvd_compat ""
	refresh_cmd_line
}

proc burn_dvd_proc {} {
	global burn_command t_session burning_device option_dvd_compat option_overburn v_create_iso v_create_iso
	if {$v_create_iso == no}  {
	set burn_command "growisofs"
	set t_session "-use-the-force-luke=tty -Z"
	set option_dvd_compat "-dvd-compat"
	set option_overburn ""
	load_options
	set_visible_options
	refresh_cmd_line
	}
}

proc create_iso_proc {} {
	global burn_command t_session burning_device option_dvd_compat option_overburn v_create_iso burn_speed
	burn_dvd_proc
	if { $v_create_iso == "yes" } {
	set_visible_options
	set burn_command "mkisofs"
	set t_session ""
	set option_dvd_compat ""
	set option_overburn ""
	set burning_device ""
	set burn_speed ""
	refresh_cmd_line
	}
}
