#    Copyright 2003 Regis Damongeot

#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

. configure -background #f5f5f5

frame .f_label_first_step -background #c7d1d1
label .f_label_first_step.l_first_step -bg #c7d1d1 -text "$i18n_step1"

frame .f_first_step -background #f5f5f5
radiobutton .f_first_step.burn_dvd -activebackground #f5f5f5 -background #f5f5f5 -highlightbackground #f5f5f5 -text "$i18n_burn_files_and_folders_on_a_dvd" -command burn_dvd_proc -variable burn_type -value burn_dvd
.f_first_step.burn_dvd select

frame .f_first_step_b -background #f5f5f5
button .f_first_step_b.add -highlightbackground blue -text "$i18n_add_files" -width 12 -command { add_file [tk_getOpenFile -multiple 1] }
button .f_first_step_b.add_d -highlightbackground blue -text "$i18n_add_directory" -width 12 -command add_d
button .f_first_step_b.delete -highlightbackground blue -text "$i18n_delete_file_dir" -width 12 -command delete_files
button .f_first_step_b.clear -highlightbackground blue -text "$i18n_clear_list" -width 12 -command { set file_list ""; refresh_total_file_size; refresh_cmd_line }
button .f_first_step_b.excluded_files -highlightbackground blue -width 12 -text "$i18n_excluded_files_dir" -command { excluded_file_window }

frame .f_upper_file_list -background #f5f5f5
label .f_upper_file_list.l_file_size -bg #f5f5f5 -text "$i18n_used_space"
entry .f_upper_file_list.show_file_size -relief flat -highlightbackground #f5f5f5 -highlightcolor #f5f5f5 -readonlybackground #f5f5f5 -state readonly -textvariable total_file_size_f -width 10
label .f_upper_file_list.l_space_left -bg #f5f5f5 -text "$i18n_free_space"
entry .f_upper_file_list.show_space_left -relief flat -highlightbackground #f5f5f5 -highlightcolor #f5f5f5 -readonlybackground #f5f5f5 -state readonly -textvariable space_left_f -width 10
button .f_upper_file_list.b_update -highlightbackground blue -text "$i18n_update" -command { refresh_total_file_size }

frame .file_list -bg #f5f5f5
listbox .file_list.file_list -bg white -listvariable file_list -yscrollcommand { .file_list.scroll_bar set }
scrollbar .file_list.scroll_bar -command { .file_list.file_list yview }

frame .f_only_create_iso -bg #f5f5f5
checkbutton .f_only_create_iso.only_create_iso -activebackground #f5f5f5 -background #f5f5f5 -highlightbackground #f5f5f5 -text "$i18n_only_create_iso9660_image" -command { create_iso_proc } -variable v_create_iso -onvalue "yes" -offvalue "no"

frame .f_first_step_iso -background #f5f5f5
radiobutton .f_first_step_iso.b_burn_iso -activebackground #f5f5f5 -background #f5f5f5 -highlightbackground #f5f5f5 -text "$i18n_burn_iso9660_image" -command { burn_iso_proc } -variable burn_type -value burn_iso
button  .f_first_step_iso.b_open_iso -highlightbackground blue -text "$i18n_open" -state disabled -command choose_iso_file -width 7
entry .f_first_step_iso.iso_file -relief flat -highlightbackground blue -highlightcolor blue -readonlybackground #f5f5f5 -state readonly -textvariable iso_file -width 57

frame .f_label_second_step -background #c7d1d1
label .f_label_second_step.l_second_step -bg #c7d1d1 -text "$i18n_step2"

frame .f_burn_dev -background #f5f5f5
label .f_burn_dev.l_burn_device -bg #f5f5f5 -width 20 -anchor w -text "$i18n_burning_device"
entry .f_burn_dev.burn_device -relief flat -bg white -highlightbackground blue -highlightcolor blue -disabledbackground #f5f5f5 -state normal -textvariable burning_device
button .f_burn_dev.b_erase_dvd_rw -highlightbackground blue -width 15 -text "$i18n_erase_dvdrw" -command { choose_format }

frame .f_vol_name -background #f5f5f5
label .f_vol_name.label_vname -bg #f5f5f5 -width 20 -anchor w -text "$i18n_volume_name"
entry .f_vol_name.volume_name -relief flat -bg white -highlightbackground blue -highlightcolor blue  -disabledbackground #f5f5f5 -state normal -textvariable volume_id_o
button .f_vol_name.b_advanced_options -highlightbackground blue -width 15 -text "$i18n_advanced_options_b" -command { advanced_options_window }

frame .f_cmd_line -background #f5f5f5
label .f_cmd_line.label_vid -bg #f5f5f5 -width 20 -anchor w -text "$i18n_command"
entry .f_cmd_line.cmd_line -relief flat -highlightbackground blue -highlightcolor blue -readonlybackground #f5f5f5 -state readonly -textvariable command_line -width 150

frame .f_burn -background #c7d1d1
button .f_burn.go_button -text "$i18n_burn" -highlightbackground red -command { refresh_total_file_size; refresh_cmd_line; launch "burn" } -width 7


pack .f_label_first_step.l_first_step -side left
pack .f_label_first_step -fill x

pack .f_first_step.burn_dvd -side left
pack .f_first_step -fill x

pack .f_first_step_b.add -side left -padx {0 10}
pack .f_first_step_b.add_d .f_first_step_b.delete .f_first_step_b.clear .f_first_step_b.excluded_files -side left -padx {10 10} -expand 0
pack .f_first_step_b.excluded_files -side right -padx {10 0}
pack .f_first_step_b -fill x -padx {50 15} -pady {7 3}

pack .f_upper_file_list.l_file_size .f_upper_file_list.show_file_size .f_upper_file_list.l_space_left .f_upper_file_list.show_space_left -side left
if { $option_auto_refresh_space == "0" } { pack .f_upper_file_list.b_update -side left }
pack .f_upper_file_list -fill x -padx {50 0}

pack .file_list.scroll_bar -fill y -side right
pack .file_list.file_list -fill both -expand 1
pack .file_list -fill both -padx {50 15} -expand 1

pack .f_only_create_iso.only_create_iso -side left
pack .f_only_create_iso -fill x -padx {50 0} -pady {0 4}

pack .f_first_step_iso.b_burn_iso -side left
pack .f_first_step_iso.iso_file -side right -padx {12 0}
pack .f_first_step_iso.b_open_iso -side right
pack .f_first_step_iso -fill x -padx {0 15}

pack .f_label_second_step.l_second_step -side left
pack .f_label_second_step -fill x  -pady {12 12}

pack .f_burn_dev.l_burn_device -side left
pack .f_burn_dev.burn_device -side left -padx {0 0}
pack .f_burn_dev.b_erase_dvd_rw -side right  -padx {0 0}
pack .f_burn_dev -fill x -padx {20 15} -pady {0 10}

pack .f_vol_name.label_vname -side left
pack .f_vol_name.volume_name -side left -padx {0 0}
pack .f_vol_name.b_advanced_options -side right -padx {0 0}
pack .f_vol_name -fill x -padx {20 15} -pady {0 10}

pack .f_cmd_line.label_vid -side left
pack .f_cmd_line.cmd_line -side left -padx {0 0}
pack .f_cmd_line -fill x  -pady {0 10} -padx {20 15}

pack .f_burn.go_button -pady {2 2}
pack .f_burn -fill x


#Create frame for burn type
#frame .frame_burn_type -background #f5f5f5
#radiobutton .frame_burn_type.burn_dvd -activebackground #f5f5f5 -background #f5f5f5 -highlightbackground #f5f5f5 -text "Burn a DVD" -command burn_dvd_proc -variable burn_type -value burn_dvd
#.frame_burn_type.burn_dvd select
#radiobutton .frame_burn_type.create_iso -activebackground #f5f5f5 -background #f5f5f5 -highlightbackground #f5f5f5 -text "Only create iso9660 image" -command { create_iso_proc } -variable burn_type -value create_iso
#radiobutton .frame_burn_type.burn_iso -activebackground #f5f5f5 -background #f5f5f5 -highlightbackground #f5f5f5 -text "Burn iso9660 image" -command { burn_iso_proc } -variable burn_type -value burn_iso
#button  .frame_burn_type.open_iso -highlightbackground blue -text "Open..." -state disabled -command choose_iso_file -width 7
#entry .frame_burn_type.iso_file -relief flat -highlightbackground blue -highlightcolor blue -state readonly -textvariable iso_file -width 35
#pack .frame_burn_type.burn_dvd .frame_burn_type.create_iso .frame_burn_type.burn_iso .frame_burn_type.open_iso -side left
#pack .frame_burn_type.iso_file -side left -padx {6 0}
#pack .frame_burn_type -fill x

# create frame for command line and burning device
#frame .frame_command_line -background #f5f5f5
#label .frame_command_line.label_b_device -bg #f5f5f5 -text "Burning device:"
#entry .frame_command_line.b_device -relief flat -bg white -highlightbackground blue -highlightcolor blue -disabledbackground #f5f5f5 -state normal -textvariable burning_device
#entry .frame_command_line.cmd_line -relief flat -highlightbackground blue -highlightcolor blue -state readonly -textvariable command_line -width 50
#button .frame_command_line.go_button -text "Burn" -highlightbackground blue -command { refresh_cmd_line; Launch } -width 7
#pack .frame_command_line.label_b_device .frame_command_line.b_device .frame_command_line.cmd_line .frame_command_line.go_button -side left
#pack .frame_command_line.go_button -side left -padx {6 0}
#pack .frame_command_line -fill x

#frame for volume id, app id, etc
#frame .volume_id -background #f5f5f5
#label .volume_id.label_vid -bg #f5f5f5 -text "Volume ID:"
#entry .volume_id.volume_id -relief flat -bg white -highlightbackground blue -highlightcolor blue  -disabledbackground #f5f5f5 -state normal -textvariable volume_id_o
#button .volume_id.b_advanced_options -highlightbackground blue -width 15 -text "Advanced Options..." -command { advanced_options_window }
#pack .volume_id.label_vid .volume_id.volume_id -side left
#pack .volume_id.b_advanced_options -padx {6 0} -side left
#pack .volume_id -fill x

#create frame for file manipulations
#frame .files_manipulations -background #f5f5f5
#pack .files_manipulations  -fill x
#button .files_manipulations.add -highlightbackground blue -text "Add Files..." -width 7 -command { if { [catch { .file_selection.open cget -state }] } { create_file_list [FileOpen $selected_directory] } }
#button .files_manipulations.add_d -highlightbackground blue -text "Add Directory..." -width 15 -command add_d
#button .files_manipulations.delete -highlightbackground blue -text "Delete File/Dir" -width 15 -command delete_files
#button .files_manipulations.clear -highlightbackground blue -text "Clear List" -width 7 -command { set file_list ""; refresh_total_file_size; refresh_cmd_line }
#button .files_manipulations.excluded_files -highlightbackground blue -width 15 -text "Excluded Files/Dir..." -command { excluded_file_window }
#pack .files_manipulations.add .files_manipulations.add_d .files_manipulations.delete .files_manipulations.clear .files_manipulations.excluded_files -side left -pady {6 6}


#create frame containing label presenting the goal of the list and file size usage/free space
#frame .f_upper_file_list -background #f5f5f5
#label .f_upper_file_list.l_text_area -bg #f5f5f5 -text "Files and directories to be burn:"
#label .f_upper_file_list.label_file_size -bg #f5f5f5 -text "Total used space:"
#entry .f_upper_file_list.show_file_size -relief flat -highlightbackground blue -highlightcolor blue -state readonly -textvariable total_file_size_f -width 10
#label .f_upper_file_list.label_space_left -bg #f5f5f5 -text "Space left:"
#entry .f_upper_file_list.show_space_left -relief flat -highlightbackground blue -highlightcolor blue -state readonly -textvariable space_left_f -width 10
#pack .f_upper_file_list.l_text_area -fill x -side left
#reverse ordering with -side right
#pack .f_upper_file_list.show_space_left .f_upper_file_list.label_space_left  .f_upper_file_list.show_file_size .f_upper_file_list.label_file_size  -side right
#pack .f_upper_file_list -fill x

#create frame for file list
#frame .file_list
#listbox .file_list.list -bg #f5f5f5 -listvariable file_list -heigh 15 -yscrollcommand { .file_list.scroll_bar set }
#scrollbar .file_list.scroll_bar -command { .file_list.list yview }
#pack .file_list -fill both -expand false
#pack .file_list.scroll_bar -side right -fill y
#pack .file_list.list -fill x

#create frame and label presenting the goal of the 2nd text area
#frame .f_upper_output_msg -background #f5f5f5
#label .f_upper_output_msg.l_text_area -bg #f5f5f5 -text "growisofs/mkisofs output messages:"
#pack .f_upper_output_msg.l_text_area -side left
#pack .f_upper_output_msg -fill x

#create output frame
#frame .output
#text .output.log -heigh 10 -bg #f5f5f5 -relief ridge -setgrid true -yscrollcommand { .output.scroll_bar set }
#scrollbar .output.scroll_bar -command { .output.log yview }
#pack .output.scroll_bar -side right -fill y
#pack .output.log -side left -fill both -expand true
#pack .output -fill both -expand true
